#include <stddef.h>
#include <stdint.h>
// TODO clean up variable names
int strncmp(const char *s1, const char *s2, unsigned int n) {
  int i;
  for(i = 0; ((i <= n) && (s1[i] != '\0') && (s2[i] != '\0')); i++) {
    if(s1[i] != s2[i]) {
      return(s1[i] - s2[i]);
    }
  }
  return(s1[i] - s2[i]);
}

int strcmp(const char *s1, const char *s2) {
  int i;
  for(i = 0; ((s1[i] != '\0') && (s2[i] != '\0')); i++) {
    if(s1[i] != s2[i]) {
      return(s1[i] - s2[i]);
    }
  }
  return(s1[i] - s2[i]);
}

int memcmp(const void *s1, const void *s2, size_t n) {
  const unsigned char *p1 = s1;
  const unsigned char *p2 = s2;
  int i;
  for(i = 0; i < n; i++) {
    if(p1[i] != p2[i]) {
      return(p1[i] - p2[i]);
    }
  }
  return(p1[n-1] - p2[n-1]);
}

void strcpy(char *dest, char *src) {
  for(unsigned int i = 0; src[i] != '\0'; i++){
    dest[i] = src[i];
  }
}

void memcpy(char *dest, char *src, size_t n) {
  for(unsigned int i = 0; i <= n; i++) {
    dest[i] = src[i];
  }
}

void bzero(void *dest, size_t size) {
  unsigned char *p1 = dest;
  for(uint64_t i = 0; i < size; i++) {
    p1[i] = 0;
  }
}

//TODO move this function to a seperate math library
int ceil(float n) {
  int low_n = (int)n;
  if(n == (float)low_n) return(low_n);
  return(low_n + 1);
}
